package com.cogitarecomputing.dualtime;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Sprite;
import flash.events.Event;
import flash.geom.Point;
import flash.geom.Rectangle;
import flash.Lib;
import flash.media.Sound;
import flash.media.SoundChannel;
import openfl.Assets;
import flash.events.MouseEvent;

/**
 * ...
 * @author 
 */

class Main extends Sprite 
{
	var inited:Bool;
	private var ship:Array<Hero>;
	private var enemies:Array<Enemy>;
	private var arena:Bitmap;
	private var arenaFront:Bitmap;
	private var bugRed:Bitmap;
	private var power:Bitmap;
	private var powerAmount:Float;
	private var shakeDownCount:Float;
	public static var arenaCollision:BitmapData;
	private var lightning1:Bitmap;
	private var lightning2:Bitmap;
	private var flBmp:Bitmap;
	private var difficulty:Float;
	private var gameOver:Bitmap;
	private var gameOverTick:Float;
	private var winner:Bitmap;
	private var winnerTick:Float;
	private var title:Bitmap;
	private var titleFade:Bool;
	private var titleFadeBack:Bool;
	private var click2play:Bitmap;
	private var instructionsButton:Bitmap;
	private var instructions:Bitmap;
	private var bonusSound:Sound;
	private var painSound:Sound;
	private var music:Sound;
	private var musicChannel:SoundChannel;
	
	/* ENTRY POINT */

	private function Resetgame():Void
	{
		powerAmount = 1.0;
		difficulty = 0.0;
		gameOverTick = 0.9;
		winnerTick = 0.0;
		allowSteering = true;
		titleFade = false;		
		for (s in ship)
		{
			s.Reset();
		}
		spawnTime = Lib.getTimer() + 10000;
	}
	
	function resize(e) 
	{
		if (!inited) init();
		// else (resize or orientation change)
	}
	
	private var mouseButtonDown:Bool;
	public function mouseMove(upEvent:MouseEvent):Void
	{		
		if (instructions.visible)
			return;
			
		if (!title.visible)
		{
			if (mouseButtonDown && allowSteering)
			{	
				ship[0].SetMV(new Point(upEvent.stageX, upEvent.stageY));
			}		
		}
		else
		{
			if (upEvent.stageX > 156 && upEvent.stageX < 480
				&& upEvent.stageY > 190 && upEvent.stageY < 251)
			{
				click2play.visible = true;
			}
			else
			{
				click2play.visible = false;
			}

			if (upEvent.stageX > 167 && upEvent.stageX < 483
			&& upEvent.stageY > 346 && upEvent.stageY < 401)
			{
				instructionsButton.visible = true;
			}
			else
			{
				instructionsButton.visible = false;
			}

		}
	}

	public function mouseUp(upEvent:MouseEvent):Void
	{		
		if (instructions.visible)
		{
			instructions.visible = false;
			return;
		}
		
		if (!title.visible)
		{
			if (allowSteering)
			{
				ship[0].SetMV(new Point(upEvent.stageX, upEvent.stageY));
			}
		}
		if (title.visible)
		{
			if (upEvent.stageX > 156 && upEvent.stageX < 480
				&& upEvent.stageY > 190 && upEvent.stageY < 251)
			{
				titleFade = true;
			}

			if (upEvent.stageX > 167 && upEvent.stageX < 483
			&& upEvent.stageY > 346 && upEvent.stageY < 401)
			{
				instructions.visible = true;
			}
		}
		mouseButtonDown = false;
	}
	
	public function mouseDown(upEvent:MouseEvent):Void
	{		
		mouseButtonDown = true;
	}
	
	private var spawnTime:Int;
	private function addEnemy():Void
	{
		if ((Lib.getTimer() - spawnTime) > (2000-(1600*difficulty)))
		{
			var p:Point = new Point();
			var r:Float = Math.random()*Math.PI*2;
			p.x = (Math.cos(r) * 320) + 320;
			p.y = (Math.sin(r) * 240) + 240;
			var rr:Float = Math.random();
			var enemyType:Int = 0;
			if (rr < 0.3)
			{
				enemyType = 0;
			}
			else if (rr < 0.9)
			{
				enemyType = 2;
			}
			else
			{
				enemyType = 1;
			}
			
			var enemy:Enemy = new Enemy(p, enemyType == 2 ? ship[1] : ship[0], enemyType);
			enemies.push(enemy);
			addChild(enemy);
			spawnTime = Lib.getTimer();
		}
	}
	private var allowSteering:Bool;
	private function enterFrame(event:Event):Void
	{
		//trace("T:" + Std.string(title.visible) + "\tg:" + Std.string(title.alpha));
		
		if (title.visible)
		{
			click2play.alpha = title.alpha;
			instructionsButton.alpha = title.alpha;
			if (titleFade)
			{
				title.alpha -= 0.05;				
				if (title.alpha < 0.0)
				{
					title.visible = false;
					title.alpha = 1.0;
					Resetgame();
				}
				return;
			}
			if (titleFadeBack)
			{
				title.alpha += 0.05;
				if (title.alpha > 1.0)
				{
					title.alpha = 1.0;
					titleFadeBack = false;
					gameOver.visible = false;
					winner.visible = false;
					for (e in enemies)
					{
						e.visible = false;
					}
					enemies = new Array<Enemy>();
				}
			}
			return;
		}
		
		click2play.visible = false;
		instructionsButton.visible = false;
		
		if (shakeDownCount > 0)
		{
			shakeDownCount -= 1.0;
			arena.x = 5*Math.cos(shakeDownCount);
			arena.y = 5*Math.sin(shakeDownCount);
			arenaFront.x = 5*Math.cos(shakeDownCount);
			arenaFront.y = 5 * Math.sin(shakeDownCount);
			bugRed.x = stage.stageWidth - bugRed.width-4+(5*Math.cos(shakeDownCount));
			bugRed.y = 4+(5 * Math.sin(shakeDownCount));
		}
		else
		{
			shakeDownCount = 0.0;
			arena.x = 0;
			arena.y = 0;
			arenaFront.x = 0;
			arenaFront.y = 0;
			bugRed.x = stage.stageWidth - bugRed.width-4;
			bugRed.y = 4;
		}
		allowSteering = true;
		var dx:Float = ship[1].x - ship[0].x;
		var dy:Float = ship[1].y - ship[0].y;
		var d:Float = Math.sqrt(dx * dx + dy * dy);
	//	if (d < 40 && ship[1].visible)
	//	{
		//	allowSteering = false;
		//	var randomAngle:Float = Math.random() * Math.PI*2;
		//	ship[0].SetMV(new Point(ship[0].x + Math.cos(randomAngle) * 40
		//	, ship[0].y + Math.sin(randomAngle) * 40));
		//}
		
		for (s in ship)
		{
			s.Update();
		}
		
		lightning1.visible = false;
		lightning2.visible = false;
		
		var bonusAchieved:Bool = false;
		var painHappened:Bool = false;
		var enemiesToRemove = new Array<Enemy>();
		for ( e in enemies)
		{
			e.Update();
			var removeEnemy:Bool = false;
			if (e.enemyType == 0)
			{
				dx = e.x - ship[0].x;
				dy = e.y - ship[0].y;
				d = dx * dx + dy * dy;
				if (d < 120)
				{
					shakeDownCount = 10.0;
					powerAmount -= 0.06;
					removeEnemy = true;
					painHappened = true;
				}
				dx = e.x - ship[1].x;
				dy = e.y - ship[1].y;
				d = dx * dx + dy * dy;
				if (d < 120)
				{
					powerAmount += 0.02;
					removeEnemy = true;
					lightning1.x = ship[0].x - lightning1.width/2;
					lightning1.y = ship[0].y - 480;
					lightning1.visible = true;
					lightning2.x = ship[1].x - lightning2.width/2;
					lightning2.y = ship[1].y - 480;
					lightning2.visible = true;
					flBmp.alpha = 1.0;
					bonusAchieved = true;
				}
			}
			
			if (e.enemyType == 2)
			{
				dx = e.x - ship[0].x;
				dy = e.y - ship[0].y;
				d = dx * dx + dy * dy;
				if (d < 120)
				{
					powerAmount += 0.02;
					removeEnemy = true;
					lightning1.x = ship[0].x - lightning1.width/2;
					lightning1.y = ship[0].y - 480;
					lightning1.visible = true;
					lightning2.x = ship[1].x - lightning2.width/2;
					lightning2.y = ship[1].y - 480;
					lightning2.visible = true;
					flBmp.alpha = 1.0;
					bonusAchieved = true;
				}
				dx = e.x - ship[1].x;
				dy = e.y - ship[1].y;
				d = dx * dx + dy * dy;
				if (d < 120)
				{
					shakeDownCount = 10.0;
					powerAmount -= 0.06;
					removeEnemy = true;
					painHappened = true;
				}
			}

			if (e.enemyType == 1)
			{
				dx = e.x - ship[0].x;
				dy = e.y - ship[0].y;
				d = dx * dx + dy * dy;
				if (d < 120)
				{
					shakeDownCount = 10.0;
					powerAmount -= 0.06;
					removeEnemy = true;
					painHappened = true;
				}
				dx = e.x - ship[1].x;
				dy = e.y - ship[1].y;
				d = dx * dx + dy * dy;
				if (d < 120)
				{
					shakeDownCount = 10.0;
					powerAmount -= 0.06;
					removeEnemy = true;
					painHappened = true;
				}
			}
			
			if (removeEnemy)
			{
				enemiesToRemove.push(e);
			}
		}
		for (e in enemiesToRemove)
		{
			enemies.remove(e);
			e.visible = false;
		}
		
		addEnemy();
		
		if (powerAmount > 1.0)
		{
			powerAmount = 1.0;
		}
		else if (powerAmount < 0.1)
		{
			if (!gameOver.visible && !winner.visible)
			{
				gameOver.visible = true;
				gameOverTick = 0.0;
			}
		}
		
		if (difficulty > 1.1)
		{
			if (!winner.visible && !gameOver.visible)
			{
				winner.visible = true;
				winnerTick = 0.0;
			}
		}
		
		pscroll += 0.01;
		power.scrollRect = new Rectangle(75 + Math.cos(pscroll) * 75, 5 + 5 * Math.sin(pscroll * 3), 50 * powerAmount, 10);
		
		if (flBmp.alpha > 0.0)
		{
			flBmp.visible = true;
			flBmp.alpha -= 0.3;
		}
		else
		{
			flBmp.alpha = 0.0;
			flBmp.visible = false;
		}
		bugRed.scrollRect = new Rectangle(0, 0, bugRed.width, 80*difficulty);
		difficulty += 0.0001;
		
		if (painHappened)
		{
			painSound.play();
		}
		if (bonusAchieved)
		{
			bonusSound.play();
		}
		if (gameOver.visible)
		{
			allowSteering = false;
			gameOverTick += 0.01;			
			gameOver.y = -640+(640 * Math.sin(gameOverTick));
			if (gameOverTick > Math.PI)
			{
				titleFadeBack = true;
				title.visible = true;
				title.alpha = 0.0;
				//trace("OVER");
			}
		}
		if (winner.visible)
		{
			allowSteering = false;
			winnerTick += 0.01;			
			winner.y = -640+(640 * Math.sin(winnerTick));
			if (winnerTick > Math.PI)
			{
				titleFadeBack = true;
				title.visible = true;
				title.alpha = 0.0;
				//trace("OVER");
			}
		}
	}
	private var pscroll:Float;
	
	function init() 
	{
		if (inited) return;
		inited = true;
		
		allowSteering = false;
		titleFade = false;
		titleFadeBack = false;
		difficulty = 0.0;
		pscroll = 0.0;
		shakeDownCount = 0.0;
		arenaCollision = Assets.getBitmapData("img/arenascollision.png");
		arena = new Bitmap(Assets.getBitmapData("img/arenas.png"));
		addChild(arena);
		bugRed = new Bitmap(Assets.getBitmapData("img/bugred.png"));
		bugRed.x = stage.stageWidth - bugRed.width-4;
		bugRed.y = 4;		
		addChild(bugRed);
		var bd:BitmapData = Assets.getBitmapData("img/lightning.png");
		lightning1 = new Bitmap(bd);
		lightning1.visible = false;
		addChild(lightning1);
		lightning2 = new Bitmap(bd);
		lightning2.visible = false;
		addChild(lightning2);

		power = new Bitmap(Assets.getBitmapData("img/power2.png"));
		power.scrollRect = new Rectangle(10, 0, 65, 20);
		power.x = 37;
		power.y = 45;
		addChild(power);
		mouseButtonDown = false;
		spawnTime = Lib.getTimer()+10000;
		powerAmount = 0.1;
		enemies = new Array<Enemy>();
				
		ship = new Array<Hero>();
		ship.push(new Hero(new Point (320,240), false));		
		ship.push(new Hero(new Point(320,240), true));
		for (s in ship)
		{
			addChild(s);
		}
		
		flBmp = new Bitmap(new BitmapData(640, 480, true, 0xffffffff));
		flBmp.visible = false;
		flBmp.alpha = 0.0;
		addChild(flBmp);
		arenaFront = new Bitmap(Assets.getBitmapData("img/arenasfront.png"));
		addChild(arenaFront);
		
		gameOver = new Bitmap(Assets.getBitmapData("img/gameover.png"));
		gameOver.visible = false;
		gameOver.x = 0;
		gameOver.y = -640;
		addChild(gameOver);
		
		winner = new Bitmap(Assets.getBitmapData("img/winner.png"));
		winner.visible = false;
		winner.x = 0;
		winner.y = -640;
		addChild(winner);
		
		title = new Bitmap(Assets.getBitmapData("img/title.jpg"));
		title.visible = true;
		addChild(title);

		click2play = new Bitmap(Assets.getBitmapData("img/click2play.png"));
		click2play.visible = false;
		click2play.x = 157;//480
		click2play.y = 191;//251
		addChild(click2play);

		instructionsButton = new Bitmap(Assets.getBitmapData("img/instructionsbutton.png"));
		instructionsButton.visible = false;
		instructionsButton.x = 168;//483
		instructionsButton.y = 346;//401
		addChild(instructionsButton);
		
		instructions = new Bitmap(Assets.getBitmapData("img/instructions.jpg"));
		instructions.visible = false;
		addChild(instructions);
		
		bonusSound = Assets.getSound("snd/bonus.wav");
		painSound = Assets.getSound("snd/pain.wav");
		painSound.play();
		music = Assets.getSound("snd/baseline.mp3");
		musicChannel = music.play();
		musicChannel.addEventListener (Event.SOUND_COMPLETE, onSoundComplete1);
		
		addEventListener(MouseEvent.MOUSE_UP, mouseUp);
		addEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
		addEventListener(MouseEvent.MOUSE_MOVE, mouseMove);
		stage.addEventListener(Event.ENTER_FRAME, enterFrame);
	}

	private function onSoundComplete1(e:Event):Void
	{
		if (musicChannel != null)
		{
			musicChannel.stop();
		}
		musicChannel = music.play();
		musicChannel.addEventListener (Event.SOUND_COMPLETE, onSoundComplete1);
	}

	/* SETUP */

	public function new() 
	{
		super();	
		addEventListener(Event.ADDED_TO_STAGE, added);
	}

	function added(e) 
	{
		removeEventListener(Event.ADDED_TO_STAGE, added);
		stage.addEventListener(Event.RESIZE, resize);
		#if ios
		haxe.Timer.delay(init, 100); // iOS 6
		#else
		init();
		#end
	}
	
	public static function main() 
	{
		
		// static entry point
		Lib.current.stage.align = flash.display.StageAlign.TOP_LEFT;
		Lib.current.stage.scaleMode = flash.display.StageScaleMode.NO_SCALE;
		Lib.current.addChild(new Main());
	}
}
